package mods.immibis.macroblocks;

import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.util.StatCollector;
import net.minecraft.world.World;

public class ItemBlockMB extends ItemBlock {

	public ItemBlockMB(Block block) {
		super(block);
		setHasSubtypes(true);
	}
	
	private static String[] effect_names = {"bricks", "carved_bricks", "pillar", "pillar", "pillar", "small_bricks", "large_tiles", "small_tiles", "ornate_large_tiles"};
	
	@Override
	public String getItemStackDisplayName(ItemStack stack) {
		return StatCollector.translateToLocalFormatted("immibis_macroblocks.style."+getEffectName(stack)+".format", StatCollector.translateToLocal(super.getUnlocalizedName()));
	}
	
	private String getEffectName(ItemStack stack) {
		int damage = stack.getItemDamage();
		if(damage < 0 || damage >= effect_names.length)
			return "unknown";
		else
			return effect_names[damage];
	}

	@Override
	public int getMetadata(int p_77647_1_) {
		return p_77647_1_;
	}
	
	@Override
	public boolean placeBlockAt(ItemStack stack, EntityPlayer player, World world, int x, int y, int z, int side, float hitX, float hitY, float hitZ, int metadata) {
		if(super.placeBlockAt(stack, player, world, x, y, z, side, hitX, hitY, hitZ, metadata)) {
			
			if(metadata == 2) {
				// handle pillar direction
				if(side == 4 || side == 5)
					world.setBlockMetadataWithNotify(x, y, z, 3, 2);
				if(side == 2 || side == 3)
					world.setBlockMetadataWithNotify(x, y, z, 4, 2);
			}
			
			return true;
		}
		return false;
	}
	
}
